git-rebase.shon commit rebase --root: stop assuming squash_onto is unset (bb2ac4f)
   1#!/bin/sh
   2#
   3# Copyright (c) 2005 Junio C Hamano.
   4#
   5
   6SUBDIRECTORY_OK=Yes
   7OPTIONS_KEEPDASHDASH=
   8OPTIONS_STUCKLONG=t
   9OPTIONS_SPEC="\
  10git rebase [-i] [options] [--exec <cmd>] [--onto <newbase>] [<upstream>] [<branch>]
  11git rebase [-i] [options] [--exec <cmd>] [--onto <newbase>] --root [<branch>]
  12git rebase --continue | --abort | --skip | --edit-todo
  13--
  14 Available options are
  15v,verbose!         display a diffstat of what changed upstream
  16q,quiet!           be quiet. implies --no-stat
  17autostash          automatically stash/stash pop before and after
  18fork-point         use 'merge-base --fork-point' to refine upstream
  19onto=!             rebase onto given branch instead of upstream
  20p,preserve-merges! try to recreate merges instead of ignoring them
  21s,strategy=!       use the given merge strategy
  22no-ff!             cherry-pick all commits, even if unchanged
  23m,merge!           use merging strategies to rebase
  24i,interactive!     let the user edit the list of commits to rebase
  25x,exec=!           add exec lines after each commit of the editable list
  26k,keep-empty       preserve empty commits during rebase
  27f,force-rebase!    force rebase even if branch is up to date
  28X,strategy-option=! pass the argument through to the merge strategy
  29stat!              display a diffstat of what changed upstream
  30n,no-stat!         do not show diffstat of what changed upstream
  31verify             allow pre-rebase hook to run
  32rerere-autoupdate  allow rerere to update index with resolved conflicts
  33root!              rebase all reachable commits up to the root(s)
  34autosquash         move commits that begin with squash!/fixup! under -i
  35committer-date-is-author-date! passed to 'git am'
  36ignore-date!       passed to 'git am'
  37signoff            passed to 'git am'
  38whitespace=!       passed to 'git apply'
  39ignore-whitespace! passed to 'git apply'
  40C=!                passed to 'git apply'
  41S,gpg-sign?        GPG-sign commits
  42 Actions:
  43continue!          continue
  44abort!             abort and check out the original branch
  45skip!              skip current patch and continue
  46edit-todo!         edit the todo list during an interactive rebase
  47quit!              abort but keep HEAD where it is
  48"
  49. git-sh-setup
  50set_reflog_action rebase
  51require_work_tree_exists
  52cd_to_toplevel
  53
  54LF='
  55'
  56ok_to_skip_pre_rebase=
  57resolvemsg="
  58$(gettext 'Resolve all conflicts manually, mark them as resolved with
  59"git add/rm <conflicted_files>", then run "git rebase --continue".
  60You can instead skip this commit: run "git rebase --skip".
  61To abort and get back to the state before "git rebase", run "git rebase --abort".')
  62"
  63squash_onto=
  64unset onto
  65unset restrict_revision
  66cmd=
  67strategy=
  68strategy_opts=
  69do_merge=
  70merge_dir="$GIT_DIR"/rebase-merge
  71apply_dir="$GIT_DIR"/rebase-apply
  72verbose=
  73diffstat=
  74test "$(git config --bool rebase.stat)" = true && diffstat=t
  75autostash="$(git config --bool rebase.autostash || echo false)"
  76fork_point=auto
  77git_am_opt=
  78git_format_patch_opt=
  79rebase_root=
  80force_rebase=
  81allow_rerere_autoupdate=
  82# Non-empty if a rebase was in progress when 'git rebase' was invoked
  83in_progress=
  84# One of {am, merge, interactive}
  85type=
  86# One of {"$GIT_DIR"/rebase-apply, "$GIT_DIR"/rebase-merge}
  87state_dir=
  88# One of {'', continue, skip, abort}, as parsed from command line
  89action=
  90preserve_merges=
  91autosquash=
  92keep_empty=
  93test "$(git config --bool rebase.autosquash)" = "true" && autosquash=t
  94case "$(git config --bool commit.gpgsign)" in
  95true)   gpg_sign_opt=-S ;;
  96*)      gpg_sign_opt= ;;
  97esac
  98
  99read_basic_state () {
 100        test -f "$state_dir/head-name" &&
 101        test -f "$state_dir/onto" &&
 102        head_name=$(cat "$state_dir"/head-name) &&
 103        onto=$(cat "$state_dir"/onto) &&
 104        # We always write to orig-head, but interactive rebase used to write to
 105        # head. Fall back to reading from head to cover for the case that the
 106        # user upgraded git with an ongoing interactive rebase.
 107        if test -f "$state_dir"/orig-head
 108        then
 109                orig_head=$(cat "$state_dir"/orig-head)
 110        else
 111                orig_head=$(cat "$state_dir"/head)
 112        fi &&
 113        GIT_QUIET=$(cat "$state_dir"/quiet) &&
 114        test -f "$state_dir"/verbose && verbose=t
 115        test -f "$state_dir"/strategy && strategy="$(cat "$state_dir"/strategy)"
 116        test -f "$state_dir"/strategy_opts &&
 117                strategy_opts="$(cat "$state_dir"/strategy_opts)"
 118        test -f "$state_dir"/allow_rerere_autoupdate &&
 119                allow_rerere_autoupdate="$(cat "$state_dir"/allow_rerere_autoupdate)"
 120        test -f "$state_dir"/gpg_sign_opt &&
 121                gpg_sign_opt="$(cat "$state_dir"/gpg_sign_opt)"
 122}
 123
 124write_basic_state () {
 125        echo "$head_name" > "$state_dir"/head-name &&
 126        echo "$onto" > "$state_dir"/onto &&
 127        echo "$orig_head" > "$state_dir"/orig-head &&
 128        echo "$GIT_QUIET" > "$state_dir"/quiet &&
 129        test t = "$verbose" && : > "$state_dir"/verbose
 130        test -n "$strategy" && echo "$strategy" > "$state_dir"/strategy
 131        test -n "$strategy_opts" && echo "$strategy_opts" > \
 132                "$state_dir"/strategy_opts
 133        test -n "$allow_rerere_autoupdate" && echo "$allow_rerere_autoupdate" > \
 134                "$state_dir"/allow_rerere_autoupdate
 135        test -n "$gpg_sign_opt" && echo "$gpg_sign_opt" > "$state_dir"/gpg_sign_opt
 136}
 137
 138output () {
 139        case "$verbose" in
 140        '')
 141                output=$("$@" 2>&1 )
 142                status=$?
 143                test $status != 0 && printf "%s\n" "$output"
 144                return $status
 145                ;;
 146        *)
 147                "$@"
 148                ;;
 149        esac
 150}
 151
 152move_to_original_branch () {
 153        case "$head_name" in
 154        refs/*)
 155                message="rebase finished: $head_name onto $onto"
 156                git update-ref -m "$message" \
 157                        $head_name $(git rev-parse HEAD) $orig_head &&
 158                git symbolic-ref \
 159                        -m "rebase finished: returning to $head_name" \
 160                        HEAD $head_name ||
 161                die "$(eval_gettext "Could not move back to \$head_name")"
 162                ;;
 163        esac
 164}
 165
 166apply_autostash () {
 167        if test -f "$state_dir/autostash"
 168        then
 169                stash_sha1=$(cat "$state_dir/autostash")
 170                if git stash apply $stash_sha1 >/dev/null 2>&1
 171                then
 172                        echo "$(gettext 'Applied autostash.')" >&2
 173                else
 174                        git stash store -m "autostash" -q $stash_sha1 ||
 175                        die "$(eval_gettext "Cannot store \$stash_sha1")"
 176                        gettext 'Applying autostash resulted in conflicts.
 177Your changes are safe in the stash.
 178You can run "git stash pop" or "git stash drop" at any time.
 179' >&2
 180                fi
 181        fi
 182}
 183
 184finish_rebase () {
 185        apply_autostash &&
 186        { git gc --auto || true; } &&
 187        rm -rf "$state_dir"
 188}
 189
 190run_specific_rebase () {
 191        if [ "$interactive_rebase" = implied ]; then
 192                GIT_EDITOR=:
 193                export GIT_EDITOR
 194                autosquash=
 195        fi
 196        . git-rebase--$type
 197        ret=$?
 198        if test $ret -eq 0
 199        then
 200                finish_rebase
 201        elif test $ret -eq 2 # special exit status for rebase -i
 202        then
 203                apply_autostash &&
 204                rm -rf "$state_dir" &&
 205                die "Nothing to do"
 206        fi
 207        exit $ret
 208}
 209
 210run_pre_rebase_hook () {
 211        if test -z "$ok_to_skip_pre_rebase" &&
 212           test -x "$(git rev-parse --git-path hooks/pre-rebase)"
 213        then
 214                "$(git rev-parse --git-path hooks/pre-rebase)" ${1+"$@"} ||
 215                die "$(gettext "The pre-rebase hook refused to rebase.")"
 216        fi
 217}
 218
 219test -f "$apply_dir"/applying &&
 220        die "$(gettext "It looks like 'git am' is in progress. Cannot rebase.")"
 221
 222if test -d "$apply_dir"
 223then
 224        type=am
 225        state_dir="$apply_dir"
 226elif test -d "$merge_dir"
 227then
 228        if test -f "$merge_dir"/interactive
 229        then
 230                type=interactive
 231                interactive_rebase=explicit
 232        else
 233                type=merge
 234        fi
 235        state_dir="$merge_dir"
 236fi
 237test -n "$type" && in_progress=t
 238
 239total_argc=$#
 240while test $# != 0
 241do
 242        case "$1" in
 243        --no-verify)
 244                ok_to_skip_pre_rebase=yes
 245                ;;
 246        --verify)
 247                ok_to_skip_pre_rebase=
 248                ;;
 249        --continue|--skip|--abort|--quit|--edit-todo)
 250                test $total_argc -eq 2 || usage
 251                action=${1##--}
 252                ;;
 253        --onto=*)
 254                onto="${1#--onto=}"
 255                ;;
 256        --exec=*)
 257                cmd="${cmd}exec ${1#--exec=}${LF}"
 258                test -z "$interactive_rebase" && interactive_rebase=implied
 259                ;;
 260        --interactive)
 261                interactive_rebase=explicit
 262                ;;
 263        --keep-empty)
 264                keep_empty=yes
 265                ;;
 266        --preserve-merges)
 267                preserve_merges=t
 268                test -z "$interactive_rebase" && interactive_rebase=implied
 269                ;;
 270        --autosquash)
 271                autosquash=t
 272                ;;
 273        --no-autosquash)
 274                autosquash=
 275                ;;
 276        --fork-point)
 277                fork_point=t
 278                ;;
 279        --no-fork-point)
 280                fork_point=
 281                ;;
 282        --merge)
 283                do_merge=t
 284                ;;
 285        --strategy-option=*)
 286                strategy_opts="$strategy_opts $(git rev-parse --sq-quote "--${1#--strategy-option=}")"
 287                do_merge=t
 288                test -z "$strategy" && strategy=recursive
 289                ;;
 290        --strategy=*)
 291                strategy="${1#--strategy=}"
 292                do_merge=t
 293                ;;
 294        --no-stat)
 295                diffstat=
 296                ;;
 297        --stat)
 298                diffstat=t
 299                ;;
 300        --autostash)
 301                autostash=true
 302                ;;
 303        --no-autostash)
 304                autostash=false
 305                ;;
 306        --verbose)
 307                verbose=t
 308                diffstat=t
 309                GIT_QUIET=
 310                ;;
 311        --quiet)
 312                GIT_QUIET=t
 313                git_am_opt="$git_am_opt -q"
 314                verbose=
 315                diffstat=
 316                ;;
 317        --whitespace=*)
 318                git_am_opt="$git_am_opt --whitespace=${1#--whitespace=}"
 319                case "${1#--whitespace=}" in
 320                fix|strip)
 321                        force_rebase=t
 322                        ;;
 323                esac
 324                ;;
 325        --ignore-whitespace)
 326                git_am_opt="$git_am_opt $1"
 327                ;;
 328        --committer-date-is-author-date|--ignore-date|--signoff|--no-signoff)
 329                git_am_opt="$git_am_opt $1"
 330                force_rebase=t
 331                ;;
 332        -C*)
 333                git_am_opt="$git_am_opt $1"
 334                ;;
 335        --root)
 336                rebase_root=t
 337                ;;
 338        --force-rebase|--no-ff)
 339                force_rebase=t
 340                ;;
 341        --rerere-autoupdate|--no-rerere-autoupdate)
 342                allow_rerere_autoupdate="$1"
 343                ;;
 344        --gpg-sign)
 345                gpg_sign_opt=-S
 346                ;;
 347        --gpg-sign=*)
 348                gpg_sign_opt="-S${1#--gpg-sign=}"
 349                ;;
 350        --)
 351                shift
 352                break
 353                ;;
 354        *)
 355                usage
 356                ;;
 357        esac
 358        shift
 359done
 360test $# -gt 2 && usage
 361
 362if test -n "$action"
 363then
 364        test -z "$in_progress" && die "$(gettext "No rebase in progress?")"
 365        # Only interactive rebase uses detailed reflog messages
 366        if test "$type" = interactive && test "$GIT_REFLOG_ACTION" = rebase
 367        then
 368                GIT_REFLOG_ACTION="rebase -i ($action)"
 369                export GIT_REFLOG_ACTION
 370        fi
 371fi
 372
 373if test "$action" = "edit-todo" && test "$type" != "interactive"
 374then
 375        die "$(gettext "The --edit-todo action can only be used during interactive rebase.")"
 376fi
 377
 378case "$action" in
 379continue)
 380        # Sanity check
 381        git rev-parse --verify HEAD >/dev/null ||
 382                die "$(gettext "Cannot read HEAD")"
 383        git update-index --ignore-submodules --refresh &&
 384        git diff-files --quiet --ignore-submodules || {
 385                echo "$(gettext "You must edit all merge conflicts and then
 386mark them as resolved using git add")"
 387                exit 1
 388        }
 389        read_basic_state
 390        run_specific_rebase
 391        ;;
 392skip)
 393        output git reset --hard HEAD || exit $?
 394        read_basic_state
 395        run_specific_rebase
 396        ;;
 397abort)
 398        git rerere clear
 399        read_basic_state
 400        case "$head_name" in
 401        refs/*)
 402                git symbolic-ref -m "rebase: aborting" HEAD $head_name ||
 403                die "$(eval_gettext "Could not move back to \$head_name")"
 404                ;;
 405        esac
 406        output git reset --hard $orig_head
 407        finish_rebase
 408        exit
 409        ;;
 410quit)
 411        exec rm -rf "$state_dir"
 412        ;;
 413edit-todo)
 414        run_specific_rebase
 415        ;;
 416esac
 417
 418# Make sure no rebase is in progress
 419if test -n "$in_progress"
 420then
 421        state_dir_base=${state_dir##*/}
 422        cmd_live_rebase="git rebase (--continue | --abort | --skip)"
 423        cmd_clear_stale_rebase="rm -fr \"$state_dir\""
 424        die "
 425$(eval_gettext 'It seems that there is already a $state_dir_base directory, and
 426I wonder if you are in the middle of another rebase.  If that is the
 427case, please try
 428        $cmd_live_rebase
 429If that is not the case, please
 430        $cmd_clear_stale_rebase
 431and run me again.  I am stopping in case you still have something
 432valuable there.')"
 433fi
 434
 435if test -n "$rebase_root" && test -z "$onto"
 436then
 437        test -z "$interactive_rebase" && interactive_rebase=implied
 438fi
 439
 440if test -n "$interactive_rebase"
 441then
 442        type=interactive
 443        state_dir="$merge_dir"
 444elif test -n "$do_merge"
 445then
 446        type=merge
 447        state_dir="$merge_dir"
 448else
 449        type=am
 450        state_dir="$apply_dir"
 451fi
 452
 453if test -t 2 && test -z "$GIT_QUIET"
 454then
 455        git_format_patch_opt="$git_format_patch_opt --progress"
 456fi
 457
 458if test -z "$rebase_root"
 459then
 460        case "$#" in
 461        0)
 462                if ! upstream_name=$(git rev-parse --symbolic-full-name \
 463                        --verify -q @{upstream} 2>/dev/null)
 464                then
 465                        . git-parse-remote
 466                        error_on_missing_default_upstream "rebase" "rebase" \
 467                                "against" "git rebase $(gettext '<branch>')"
 468                fi
 469
 470                test "$fork_point" = auto && fork_point=t
 471                ;;
 472        *)      upstream_name="$1"
 473                if test "$upstream_name" = "-"
 474                then
 475                        upstream_name="@{-1}"
 476                fi
 477                shift
 478                ;;
 479        esac
 480        upstream=$(peel_committish "${upstream_name}") ||
 481        die "$(eval_gettext "invalid upstream '\$upstream_name'")"
 482        upstream_arg="$upstream_name"
 483else
 484        if test -z "$onto"
 485        then
 486                empty_tree=$(git hash-object -t tree /dev/null)
 487                onto=$(git commit-tree $empty_tree </dev/null)
 488                squash_onto="$onto"
 489        fi
 490        unset upstream_name
 491        unset upstream
 492        test $# -gt 1 && usage
 493        upstream_arg=--root
 494fi
 495
 496# Make sure the branch to rebase onto is valid.
 497onto_name=${onto-"$upstream_name"}
 498case "$onto_name" in
 499*...*)
 500        if      left=${onto_name%...*} right=${onto_name#*...} &&
 501                onto=$(git merge-base --all ${left:-HEAD} ${right:-HEAD})
 502        then
 503                case "$onto" in
 504                ?*"$LF"?*)
 505                        die "$(eval_gettext "\$onto_name: there are more than one merge bases")"
 506                        ;;
 507                '')
 508                        die "$(eval_gettext "\$onto_name: there is no merge base")"
 509                        ;;
 510                esac
 511        else
 512                die "$(eval_gettext "\$onto_name: there is no merge base")"
 513        fi
 514        ;;
 515*)
 516        onto=$(peel_committish "$onto_name") ||
 517        die "$(eval_gettext "Does not point to a valid commit: \$onto_name")"
 518        ;;
 519esac
 520
 521# If the branch to rebase is given, that is the branch we will rebase
 522# $branch_name -- branch/commit being rebased, or HEAD (already detached)
 523# $orig_head -- commit object name of tip of the branch before rebasing
 524# $head_name -- refs/heads/<that-branch> or "detached HEAD"
 525switch_to=
 526case "$#" in
 5271)
 528        # Is it "rebase other $branchname" or "rebase other $commit"?
 529        branch_name="$1"
 530        switch_to="$1"
 531
 532        # Is it a local branch?
 533        if git show-ref --verify --quiet -- "refs/heads/$branch_name" &&
 534           orig_head=$(git rev-parse -q --verify "refs/heads/$branch_name")
 535        then
 536                head_name="refs/heads/$branch_name"
 537        # If not is it a valid ref (branch or commit)?
 538        elif orig_head=$(git rev-parse -q --verify "$branch_name")
 539        then
 540                head_name="detached HEAD"
 541
 542        else
 543                die "$(eval_gettext "fatal: no such branch/commit '\$branch_name'")"
 544        fi
 545        ;;
 5460)
 547        # Do not need to switch branches, we are already on it.
 548        if branch_name=$(git symbolic-ref -q HEAD)
 549        then
 550                head_name=$branch_name
 551                branch_name=$(expr "z$branch_name" : 'zrefs/heads/\(.*\)')
 552        else
 553                head_name="detached HEAD"
 554                branch_name=HEAD
 555        fi
 556        orig_head=$(git rev-parse --verify HEAD) || exit
 557        ;;
 558*)
 559        die "BUG: unexpected number of arguments left to parse"
 560        ;;
 561esac
 562
 563if test "$fork_point" = t
 564then
 565        new_upstream=$(git merge-base --fork-point "$upstream_name" \
 566                        "${switch_to:-HEAD}")
 567        if test -n "$new_upstream"
 568        then
 569                restrict_revision=$new_upstream
 570        fi
 571fi
 572
 573if test "$autostash" = true && ! (require_clean_work_tree) 2>/dev/null
 574then
 575        stash_sha1=$(git stash create "autostash") ||
 576        die "$(gettext 'Cannot autostash')"
 577
 578        mkdir -p "$state_dir" &&
 579        echo $stash_sha1 >"$state_dir/autostash" &&
 580        stash_abbrev=$(git rev-parse --short $stash_sha1) &&
 581        echo "$(eval_gettext 'Created autostash: $stash_abbrev')" &&
 582        git reset --hard
 583fi
 584
 585require_clean_work_tree "rebase" "$(gettext "Please commit or stash them.")"
 586
 587# Now we are rebasing commits $upstream..$orig_head (or with --root,
 588# everything leading up to $orig_head) on top of $onto
 589
 590# Check if we are already based on $onto with linear history,
 591# but this should be done only when upstream and onto are the same
 592# and if this is not an interactive rebase.
 593mb=$(git merge-base "$onto" "$orig_head")
 594if test "$type" != interactive && test "$upstream" = "$onto" &&
 595        test "$mb" = "$onto" && test -z "$restrict_revision" &&
 596        # linear history?
 597        ! (git rev-list --parents "$onto".."$orig_head" | sane_grep " .* ") > /dev/null
 598then
 599        if test -z "$force_rebase"
 600        then
 601                # Lazily switch to the target branch if needed...
 602                test -z "$switch_to" ||
 603                GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: checkout $switch_to" \
 604                        git checkout -q "$switch_to" --
 605                if test "$branch_name" = "HEAD" &&
 606                         ! git symbolic-ref -q HEAD
 607                then
 608                        say "$(eval_gettext "HEAD is up to date.")"
 609                else
 610                        say "$(eval_gettext "Current branch \$branch_name is up to date.")"
 611                fi
 612                finish_rebase
 613                exit 0
 614        else
 615                if test "$branch_name" = "HEAD" &&
 616                         ! git symbolic-ref -q HEAD
 617                then
 618                        say "$(eval_gettext "HEAD is up to date, rebase forced.")"
 619                else
 620                        say "$(eval_gettext "Current branch \$branch_name is up to date, rebase forced.")"
 621                fi
 622        fi
 623fi
 624
 625# If a hook exists, give it a chance to interrupt
 626run_pre_rebase_hook "$upstream_arg" "$@"
 627
 628if test -n "$diffstat"
 629then
 630        if test -n "$verbose"
 631        then
 632                echo "$(eval_gettext "Changes from \$mb to \$onto:")"
 633        fi
 634        # We want color (if set), but no pager
 635        GIT_PAGER='' git diff --stat --summary "$mb" "$onto"
 636fi
 637
 638test "$type" = interactive && run_specific_rebase
 639
 640# Detach HEAD and reset the tree
 641say "$(gettext "First, rewinding head to replay your work on top of it...")"
 642
 643GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: checkout $onto_name" \
 644        git checkout -q "$onto^0" || die "could not detach HEAD"
 645git update-ref ORIG_HEAD $orig_head
 646
 647# If the $onto is a proper descendant of the tip of the branch, then
 648# we just fast-forwarded.
 649if test "$mb" = "$orig_head"
 650then
 651        say "$(eval_gettext "Fast-forwarded \$branch_name to \$onto_name.")"
 652        move_to_original_branch
 653        finish_rebase
 654        exit 0
 655fi
 656
 657if test -n "$rebase_root"
 658then
 659        revisions="$onto..$orig_head"
 660else
 661        revisions="${restrict_revision-$upstream}..$orig_head"
 662fi
 663
 664run_specific_rebase